package  org.example;
import java.util.Random;
import java.util.Scanner;

import org.example.BeatThemAllGame.PreemptiveStrike;

public class Battle {

    public static void battle(Scanner scanner, Hero hero, Enemy enemy) {
        if (hero.specialAbility instanceof PreemptiveStrike && !hero.specialUsed) {
            hero.useSpecialAbility(enemy);
            hero.specialUsed = true;
            if (!enemy.isAlive()) {
                System.out.println("Vous avez vaincu " + enemy.name + " avant même qu'il puisse agir !");
                Logger.getInstance().log(hero.name + " a vaincu " + enemy.name + " avec une attaque préventive");
                return;
            }
        }

        while (hero.isAlive() && enemy.isAlive()) {
            System.out.println("\n=== Votre tour ===");
            System.out.println("1. Attaquer");
            System.out.println("2. Utiliser la capacité spéciale");
            System.out.println("3. Utiliser un objet");
            System.out.print("Votre choix : ");
            int choice = scanner.nextInt();

            switch (choice) {
                case 1:
                    hero.attack(enemy);
                    break;
                case 2:
                    hero.useSpecialAbility(enemy);
                    break;
                case 3:
                    hero.useItem();
                    break;
                default:
                    System.out.println("Choix invalide, vous perdez votre tour !");
                    break;
            }

            if (enemy.isAlive()) {
                System.out.println("\n=== Tour de l'ennemi ===");

                if (enemy.specialAbility != null && new Random().nextInt(100) < 30) {
                    enemy.useSpecialAbility(hero);
                    Logger.getInstance().log(enemy.name + " utilise sa capacité spéciale");
                } else {
                    enemy.attack(hero);
                }
            } else {
                System.out.println("Vous avez vaincu " + enemy.name + " !");
                Logger.getInstance().log(hero.name + " a vaincu " + enemy.name);
            }
        }
    }
}